#include <bits/stdc++.h>

using namespace std;

void nadji(int koji, int a[], stack<int> *res, int n) {
    for(int i = 0; i < n; i++) if(abs(a[i]) == abs(koji)) (*res).push(i);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    resenje:
    while(t--) {
        int n, a[30001], b[30001];
        cin >> n;
        for(int i = 0; i < n; i++) cin >> a[i];
        for(int i = 0; i < n; i++) cin >> b[i];
        for(int j = n - 1; j >= 0; j--) {
            stack<int> gde;
            nadji(b[j], a, &gde, n);
            sasTiCut:
            if(gde.empty()) {
                cout << "NE\n";
                goto resenje;
            }
            if((j - gde.top()) % 2 && a[gde.top()] == b[j]) {
                gde.pop();
                goto sasTiCut;
            }
            else if(!((j - gde.top()) % 2) && a[gde.top()] != b[j]) {
                gde.pop();
                goto sasTiCut;
            }
            else {
                for(int i = gde.top(); i < j; i++) {
                    swap(a[i], a[i + 1]);
                    a[i] = -a[i];
                    a[i + 1] = -a[i + 1];
                }
            }
        }
        cout << "DA\n";
    }
}